net.sf.saxon.dom

## Class DOMNodeWrapper

- java.lang.Object
- - net.sf.saxon.tree.wrapper.AbstractNodeWrapper
  - - net.sf.saxon.dom.DOMNodeWrapper

- All Implemented Interfaces:
    Source, PullEvent, Item, NodeInfo, Sequence, SteppingNode, SiblingCountingNode, VirtualNode
  Direct Known Subclasses:
    DocumentWrapper

      public class DOMNodeWrapper
      extends AbstractNodeWrapper
      implements SiblingCountingNode, SteppingNode

  A node in the XML parse tree representing an XML element, character content, or attribute.

  This is the implementation of the NodeInfo interface used as a wrapper for DOM nodes.

  Because the DOM is not thread-safe even when reading, and because Saxon-EE can spawn multiple threads that access the same input tree, all methods that invoke DOM methods are synchronized on the DocumentWrapper object. (This still relies on the user not allocating two DocumentWrappers around the same DOM).

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected DocumentWrapper` | `docWrapper`
    `protected int` | `index`
    `protected Node` | `node`
    `protected short` | `nodeKind`
    `protected int` | `span`

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `ALL_NAMESPACES, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `DOMNodeWrapper(Node node, DocumentWrapper docWrapper, DOMNodeWrapper parent, int index)` This constructor is protected: nodes should be created using the makeWrapper factory method

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
    `int` | `comparePosition(NodeInfo other)` Determine the relative position of this node and another node, in document order, distinguishing whether the first node is a preceding, following, descendant, ancestor, or the same node as the second.
    `void` | `copy(Receiver out, int copyOptions, int locationId)` Copy this node to a given outputter (deep copy)
    `void` | `generateId(FastStringBuffer buffer)` Get a character string that uniquely identifies this node.
    `static String` | `getAttributeURI(Attr attr)`
    `String` | `getAttributeValue(String uri, String local)` Get the string value of a given attribute of this node
    `NamespaceBinding[]` | `getDeclaredNamespaces(NamespaceBinding[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
    `String` | `getDisplayName()` Get the display name of this node.
    `long` | `getDocumentNumber()` Get the document number of the document containing this node.
    `DocumentInfo` | `getDocumentRoot()` Get the root (document) node
    `static String` | `getElementURI(Element element)`
    `DOMNodeWrapper` | `getFirstChild()` Get the first child of this node
    `static String` | `getLocalName(Node node)` Get the local name of a DOM element or attribute node.
    `String` | `getLocalPart()` Get the local part of the name of this node.
    `int` | `getNameCode()` Get name code.
    `DOMNodeWrapper` | `getNextSibling()` Get the next sibling of this node
    `int` | `getNodeKind()` Return the kind of node.
    `DOMNodeWrapper` | `getParent()` Get the NodeInfo object representing the parent of this node
    `String` | `getPrefix()` Get the prefix of the name of the node.
    `DOMNodeWrapper` | `getPreviousSibling()` Get the previous sibling of this node
    `NodeInfo` | `getRoot()` Get the root node - always a document node with this tree implementation
    `int` | `getSiblingPosition()` Get the index position of this node among its siblings (starting from 0).
    `CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
    `SteppingNode` | `getSuccessorElement(SteppingNode anchor, String uri, String local)` Find the next matching element in document order; that is, the first child element with the required name if there is one; otherwise the next sibling element if there is one; otherwise the next sibling element of the parent, grandparent, etc, up to the anchor element.
    `Object` | `getUnderlyingNode()` Get the underlying DOM node, to implement the VirtualNode interface
    `String` | `getURI()` Get the URI part of the name of this node.
    `boolean` | `hasChildNodes()` Determine whether the node has any children.
    `boolean` | `isId()` Determine whether this node has the is-id property
    `boolean` | `isSameNodeInfo(NodeInfo other)` Determine whether this is the same node as another node.
    `protected AxisIterator<NodeInfo>` | `iterateAttributes(NodeTest nodeTest)` Return an iterator over the attributes of this element node.
    `protected AxisIterator<NodeInfo>` | `iterateChildren(NodeTest nodeTest)` Return an iterator over the children of this node.
    `protected AxisIterator<NodeInfo>` | `iterateDescendants(NodeTest nodeTest, boolean includeSelf)` Return an iterator over the descendants of this node.
    `protected AxisIterator<NodeInfo>` | `iterateSiblings(NodeTest nodeTest, boolean forwards)` Return an iterator over the siblings of this node.
    `protected DOMNodeWrapper` | `makeWrapper(Node node, DocumentWrapper docWrapper)` Factory method to wrap a DOM node with a wrapper that implements the Saxon NodeInfo interface.
    `protected DOMNodeWrapper` | `makeWrapper(Node node, DocumentWrapper docWrapper, DOMNodeWrapper parent, int index)` Factory method to wrap a DOM node with a wrapper that implements the Saxon NodeInfo interface.

    - ### Methods inherited from class net.sf.saxon.tree.wrapper.AbstractNodeWrapper

      `atomize, equals, getBaseURI, getColumnNumber, getConfiguration, getFingerprint, getLineNumber, getNamePool, getRealNode, getSchemaType, getStringValue, getSystemId, getTypeAnnotation, hashCode, head, isIdref, isNilled, iterate, iterateAxis, iterateAxis, setSystemId`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `atomize, equals, getBaseURI, getColumnNumber, getConfiguration, getFingerprint, getLineNumber, getNamePool, getSchemaType, getStringValue, getSystemId, getTypeAnnotation, hashCode, isIdref, isNilled, iterateAxis, iterateAxis`

    - ### Methods inherited from interface javax.xml.transform.Source

      `setSystemId`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `head, iterate`

- - ### Field Detail

    - #### node

          protected Node node

    - #### nodeKind

          protected short nodeKind

    - #### docWrapper

          protected DocumentWrapper docWrapper

    - #### index

          protected int index

    - #### span

          protected int span

  - ### Constructor Detail

    - #### DOMNodeWrapper

          protected DOMNodeWrapper(Node node,
                        DocumentWrapper docWrapper,
                        DOMNodeWrapper parent,
                        int index)

      This constructor is protected: nodes should be created using the makeWrapper factory method
      Parameters:
        `node` - The DOM node to be wrapped
        `docWrapper` - The wrapper for the Document node at the root of the DOM tree. Never null except in the case where we are creating the DocumentWrapper itself (which is a subclass).
        `parent` - The DOMNodeWrapper that wraps the parent of this node. May be null if unknown.
        `index` - Position of this node among its siblings, 0-based. May be -1 if unknown.

  - ### Method Detail

    - #### makeWrapper

          protected DOMNodeWrapper makeWrapper(Node node,
                                   DocumentWrapper docWrapper)

      Factory method to wrap a DOM node with a wrapper that implements the Saxon NodeInfo interface.
      Parameters:
        `node` - The DOM node
        `docWrapper` - The wrapper for the containing Document node
      Returns:
        The new wrapper for the supplied node
      Throws:
        `NullPointerException` - if the node or the document wrapper are null

    - #### makeWrapper

          protected DOMNodeWrapper makeWrapper(Node node,
                                   DocumentWrapper docWrapper,
                                   DOMNodeWrapper parent,
                                   int index)

      Factory method to wrap a DOM node with a wrapper that implements the Saxon NodeInfo interface.
      Parameters:
        `node` - The DOM node
        `docWrapper` - The wrapper for the containing Document node *
        `parent` - The wrapper for the parent of the JDOM node
        `index` - The position of this node relative to its siblings
      Returns:
        The new wrapper for the supplied node

    - #### getUnderlyingNode

          public Object getUnderlyingNode()

      Get the underlying DOM node, to implement the VirtualNode interface
      Specified by:
        `getUnderlyingNode` in interface `VirtualNode`
      Returns:
        The underlying node.

    - #### getNodeKind

          public int getNodeKind()

      Return the kind of node.
      Specified by:
        `getNodeKind` in interface `NodeInfo`
      Returns:
        one of the values Node.ELEMENT, Node.TEXT, Node.ATTRIBUTE, etc.
      See Also:
        `Type`

    - #### isSameNodeInfo

          public boolean isSameNodeInfo(NodeInfo other)

      Determine whether this is the same node as another node.
      Note: a.isSameNodeInfo(b) if and only if generateId(a)==generateId(b)
      Specified by:
        `isSameNodeInfo` in interface `NodeInfo`
      Overrides:
        `isSameNodeInfo` in class `AbstractNodeWrapper`
      Parameters:
        `other` - the node to be compared with this node
      Returns:
        true if this Node object and the supplied Node object represent the same node in the tree.

    - #### compareOrder

          public int compareOrder(NodeInfo other)

      Determine the relative position of this node and another node, in document order. The other node will always be in the same document.
      Specified by:
        `compareOrder` in interface `NodeInfo`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

    - #### comparePosition

          public int comparePosition(NodeInfo other)

      Determine the relative position of this node and another node, in document order, distinguishing whether the first node is a preceding, following, descendant, ancestor, or the same node as the second.

      The other node must always be in the same tree; the effect of calling this method when the two nodes are in different trees is undefined. If either node is a namespace or attribute node, the method should throw UnsupportedOperationException.
      Specified by:
        `comparePosition` in interface `NodeInfo`
      Overrides:
        `comparePosition` in class `AbstractNodeWrapper`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        `AxisInfo.PRECEDING` if this node is on the preceding axis of the other node; `AxisInfo.FOLLOWING` if it is on the following axis; `AxisInfo.ANCESTOR` if the first node is an ancestor of the second; `AxisInfo.DESCENDANT` if the first is a descendant of the second; `AxisInfo.SELF` if they are the same node.
      Throws:
        `UnsupportedOperationException` - if either node is an attribute or namespace
      Since:
        9.5

    - #### getStringValueCS

          public CharSequence getStringValueCS()

      Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.
      Specified by:
        `getStringValueCS` in interface `Item`
      Returns:
        the string value of the item
      See Also:
        `Item.getStringValue()`

    - #### getNameCode

          public int getNameCode()

      Get name code. The name code is a coded form of the node name: two nodes with the same name code have the same namespace URI, the same local name, and the same prefix. By masking the name code with &0xfffff, you get a fingerprint: two nodes with the same fingerprint have the same local name and namespace URI.
      Specified by:
        `getNameCode` in interface `NodeInfo`
      Overrides:
        `getNameCode` in class `AbstractNodeWrapper`
      Returns:
        an integer name code, which may be used to obtain the actual node name from the name pool. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.
      See Also:
        `allocate`

    - #### getLocalPart

          public String getLocalPart()

      Get the local part of the name of this node. This is the name after the ":" if any.
      Specified by:
        `getLocalPart` in interface `NodeInfo`
      Returns:
        the local part of the name. For an unnamed node, returns null, except for un unnamed namespace node, which returns "".

    - #### getLocalName

          public static String getLocalName(Node node)

      Get the local name of a DOM element or attribute node.
      Parameters:
        `node` - the DOM element or attribute node
      Returns:
        the local name as defined in XDM

    - #### getURI

          public String getURI()

      Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.
      Specified by:
        `getURI` in interface `NodeInfo`
      Returns:
        The URI of the namespace of this node. For an unnamed node, or for a node with an empty prefix, return an empty string.

    - #### getElementURI

          public static String getElementURI(Element element)

    - #### getAttributeURI

          public static String getAttributeURI(Attr attr)

    - #### getPrefix

          public String getPrefix()

      Get the prefix of the name of the node. This is defined only for elements and attributes. If the node has no prefix, or for other kinds of node, return a zero-length string.
      Specified by:
        `getPrefix` in interface `NodeInfo`
      Returns:
        The prefix of the name of the node.

    - #### getDisplayName

          public String getDisplayName()

      Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.
      Specified by:
        `getDisplayName` in interface `NodeInfo`
      Overrides:
        `getDisplayName` in class `AbstractNodeWrapper`
      Returns:
        The display name of this node. For a node with no name, return an empty string.

    - #### getParent

          public DOMNodeWrapper getParent()

      Get the NodeInfo object representing the parent of this node
      Specified by:
        `getParent` in interface `NodeInfo`
      Specified by:
        `getParent` in interface `SteppingNode`
      Returns:
        the parent of this node; null if this node has no parent

    - #### getSiblingPosition

          public int getSiblingPosition()

      Get the index position of this node among its siblings (starting from 0). In the case of a text node that maps to several adjacent siblings in the DOM, the numbering actually refers to the position of the underlying DOM nodes; thus the sibling position for the text node is that of the first DOM node to which it relates, and the numbering of subsequent XPath nodes is not necessarily consecutive.

      Despite the name, this method also returns a meaningful result for attribute nodes; it returns the position of the attribute among the attributes of its parent element, when they are listed in document order.

      Specified by:
        `getSiblingPosition` in interface `SiblingCountingNode`
      Returns:
        0 for the first child, 1 for the second child, etc.

    - #### iterateAttributes

          protected AxisIterator<NodeInfo> iterateAttributes(NodeTest nodeTest)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the attributes of this element node. This method is only called after checking that the node is an element.
      Specified by:
        `iterateAttributes` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned attributes must satisfy
      Returns:
        an iterator over the attribute nodes. The order of the result, although arbitrary, must be consistent with document order.

    - #### iterateChildren

          protected AxisIterator<NodeInfo> iterateChildren(NodeTest nodeTest)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the children of this node. This method is only called after checking that the node is an element or document.
      Specified by:
        `iterateChildren` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned attributes must satisfy
      Returns:
        an iterator over the child nodes, in document order.

    - #### iterateSiblings

          protected AxisIterator<NodeInfo> iterateSiblings(NodeTest nodeTest,
                                               boolean forwards)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the siblings of this node. This method is only called after checking that the node is an element, text, comment, or PI node.
      Specified by:
        `iterateSiblings` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned siblings must satisfy
        `forwards` - true for following siblings, false for preceding siblings
      Returns:
        an iterator over the sibling nodes, in axis order.

    - #### iterateDescendants

          protected AxisIterator<NodeInfo> iterateDescendants(NodeTest nodeTest,
                                                  boolean includeSelf)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the descendants of this node. This method is only called after checking that the node is an element or document node.
      Specified by:
        `iterateDescendants` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned descendants must satisfy
        `includeSelf` - true if this node is to be included in the result
      Returns:
        an iterator over the sibling nodes, in axis order.

    - #### getAttributeValue

          public String getAttributeValue(String uri,
                                 String local)

      Get the string value of a given attribute of this node
      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Overrides:
        `getAttributeValue` in class `AbstractNodeWrapper`
      Parameters:
        `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
        `local` - the local part of the attribute name.
      Returns:
        the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
      Since:
        9.4

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node - always a document node with this tree implementation
      Specified by:
        `getRoot` in interface `NodeInfo`
      Overrides:
        `getRoot` in class `AbstractNodeWrapper`
      Returns:
        the NodeInfo representing the containing document

    - #### getDocumentRoot

          public DocumentInfo getDocumentRoot()

      Get the root (document) node
      Specified by:
        `getDocumentRoot` in interface `NodeInfo`
      Returns:
        the DocumentInfo representing the containing document

    - #### hasChildNodes

          public boolean hasChildNodes()

      Determine whether the node has any children.
      Note: the result is equivalent to
      getEnumeration(Axis.CHILD, AnyNodeTest.getInstance()).hasNext()
      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Overrides:
        `hasChildNodes` in class `AbstractNodeWrapper`
      Returns:
        True if the node has one or more children

    - #### generateId

          public void generateId(FastStringBuffer buffer)

      Get a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)
      Specified by:
        `generateId` in interface `NodeInfo`
      Parameters:
        `buffer` - a buffer to contain a string that uniquely identifies this node, across all documents

    - #### getDocumentNumber

          public long getDocumentNumber()

      Get the document number of the document containing this node. For a free-standing orphan node, just return the hashcode.
      Specified by:
        `getDocumentNumber` in interface `NodeInfo`
      Overrides:
        `getDocumentNumber` in class `AbstractNodeWrapper`
      Returns:
        the document number of the document containing this node

    - #### copy

          public void copy(Receiver out,
                  int copyOptions,
                  int locationId)
                    throws XPathException

      Copy this node to a given outputter (deep copy)
      Specified by:
        `copy` in interface `NodeInfo`
      Overrides:
        `copy` in class `AbstractNodeWrapper`
      Parameters:
        `out` - the Receiver to which the node should be copied. It is the caller's responsibility to ensure that this Receiver is open before the method is called (or that it is self-opening), and that it is closed after use.
        `copyOptions` - a selection of the options defined in `CopyOptions`
        `locationId` - If non-zero, identifies the location of the instruction that requested this copy. If zero, indicates that the location information
      Throws:
        `XPathException` - if any downstream error occurs

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces(NamespaceBinding[] buffer)

      Get all namespace undeclarations and undeclarations defined on this element.
      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Overrides:
        `getDeclaredNamespaces` in class `AbstractNodeWrapper`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

        For a node other than an element, the method returns null.

    - #### isId

          public boolean isId()

      Determine whether this node has the is-id property
      Specified by:
        `isId` in interface `NodeInfo`
      Overrides:
        `isId` in class `AbstractNodeWrapper`
      Returns:
        true if the node is an ID

    - #### getNextSibling

          public DOMNodeWrapper getNextSibling()

      Description copied from interface: `SteppingNode`
      Get the next sibling of this node
      Specified by:
        `getNextSibling` in interface `SteppingNode`
      Returns:
        the next sibling if there is one, or null otherwise

    - #### getFirstChild

          public DOMNodeWrapper getFirstChild()

      Description copied from interface: `SteppingNode`
      Get the first child of this node
      Specified by:
        `getFirstChild` in interface `SteppingNode`
      Returns:
        the first child if there is one, or null otherwise

    - #### getPreviousSibling

          public DOMNodeWrapper getPreviousSibling()

      Description copied from interface: `SteppingNode`
      Get the previous sibling of this node
      Specified by:
        `getPreviousSibling` in interface `SteppingNode`
      Returns:
        the previous sibling if there is one, or null otherwise

    - #### getSuccessorElement

          public SteppingNode getSuccessorElement(SteppingNode anchor,
                                         String uri,
                                         String local)

      Description copied from interface: `SteppingNode`
      Find the next matching element in document order; that is, the first child element with the required name if there is one; otherwise the next sibling element if there is one; otherwise the next sibling element of the parent, grandparent, etc, up to the anchor element.
      Specified by:
        `getSuccessorElement` in interface `SteppingNode`
      Parameters:
        `anchor` - the root of the tree within which navigation is confined
        `uri` - the required namespace URI, or null if any namespace is acceptable
        `local` - the required local name, or null if any local name is acceptable
      Returns:
        the next element after this one in document order, with the given URI and local name if specified, or null if this is the last node in the document, or the last node within the subtree being navigated

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.